diff -ruN versions/nakedmudv3.6/src/scripts/pymudsys.c src/scripts/pymudsys.c
--- versions/nakedmudv3.6/src/scripts/pymudsys.c	2008-05-31 01:43:38.000000000 -0400
+++ src/scripts/pymudsys.c	2008-12-03 17:51:12.000000000 -0500
@@ -16,6 +16,8 @@
 #include "../save.h"
 #include "../handler.h"
 #include "../account.h"
+#include "../storage.h"
+#include "../world.h"
 
 #include "pymudsys.h"
 #include "scripts.h"
@@ -23,6 +25,11 @@
 #include "pychar.h"
 #include "pyaccount.h"
 #include "pysocket.h"
+#include "pyroom.h"
+#include "pyexit.h"
+#include "pyobj.h"
+#include "pystorage.h"
+
 
 
 //******************************************************************************
@@ -36,6 +43,10 @@
 //*****************************************************************************
 // local variables and functions
 //*****************************************************************************
+
+// a dictionary of world types and their appropriate Python class
+PyObject *worldtypes = NULL;
+
 // a list of methods to add to the mudsys module
 LIST *pymudsys_methods = NULL;
 
@@ -569,6 +580,7 @@
       bufferFormat(buf, SCREEN_WIDTH, 0);
       if(bufferLength(buf) > 0)
 	add_help(name, bufferString(buf), group, NULL, FALSE);
+      deleteBuffer(buf);
     }
 #endif
   }
@@ -660,6 +672,188 @@
 
 
 //*****************************************************************************
+// functions for adding methods to classes within Python
+//*****************************************************************************
+PyObject *mudsys_gen_add_method(PyTypeObject *type, PyObject *args) {
+  PyObject *pyname = NULL;
+  PyObject *method = NULL;
+  char       *name = NULL;
+
+  if(!PyArg_ParseTuple(args, "OO", &pyname, &method)) {
+    PyErr_Format(PyExc_TypeError, "Method takes string and function argument.");
+    return NULL;
+  }
+
+  if(!PyString_Check(pyname)) {
+    PyErr_Format(PyExc_TypeError, "First argument not a string.");
+    return NULL;
+  }
+
+  if(!PyFunction_Check(method)) {
+    PyErr_Format(PyExc_TypeError, "Second argument not a function.");
+    return NULL;
+  }
+
+  name = PyString_AsString(pyname);
+  if(PyDict_Contains(type->tp_dict, pyname)) {
+    PyErr_Format(PyExc_TypeError, "%s already has attribute, %s.", 
+		 type->tp_name, name);
+    return NULL;
+  }
+
+  // add our new method
+  PyDict_SetItemString(type->tp_dict, name, method);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_add_sock_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PySocket_Type, args);
+}
+PyObject *mudsys_add_room_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PyRoom_Type, args);
+}
+PyObject *mudsys_add_exit_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PyExit_Type, args);
+}
+PyObject *mudsys_add_obj_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PyObj_Type, args);
+}
+PyObject *mudsys_add_char_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PyChar_Type, args);
+}
+PyObject *mudsys_add_acct_method(PyObject *self, PyObject *args) {
+  return mudsys_gen_add_method(&PyAccount_Type, args);
+}
+
+
+
+//*****************************************************************************
+// functions for adding and getting types to the gameworld
+//*****************************************************************************
+void pytype_set_key(const char *type, PyObject *thing, const char *key) {
+  PyObject *ret = PyObject_CallMethod(thing, "setKey", "s", key);
+  if(ret == NULL)
+    log_pyerr("error calling setKey for world type, %s", type);
+  Py_XDECREF(ret);
+}
+
+PyObject *pytype_read(const char *type, STORAGE_SET *set) {
+  PyObject *thing = PyDict_GetItemString(worldtypes, type);
+
+  if(thing == NULL) {
+    log_pyerr("world type, %s, does not exist", type);
+    return NULL;
+  }
+  else {
+    PyObject *pystore = newPyStorageSet(set);
+    PyObject    *copy = PyObject_CallFunction(thing, "O", pystore);
+
+    // did it work?
+    if(copy == NULL)
+      log_pyerr("Error reading world type, %s", type);
+    Py_XDECREF(pystore);
+    return copy;
+  }
+}
+
+STORAGE_SET *pytype_store(const char *type, PyObject *thing) {
+  PyObject *pystore = PyObject_CallMethod(thing, "store", NULL);
+  STORAGE_SET  *set = NULL;
+  // make sure it worked
+  if(pystore != NULL)
+    set = PyStorageSet_AsSet(pystore);
+  else {
+    log_pyerr("error calling store for world type, %s", type);
+    set = new_storage_set();
+  }
+  Py_XDECREF(pystore);
+  return set;
+}
+
+void pytype_delete(const char *type, PyObject *thing) {
+  Py_XDECREF(thing);
+}
+
+PyObject *mudsys_world_add_type(PyObject *self, PyObject *args) {
+  char      *type = NULL;
+  PyObject *class = NULL;
+  if(!PyArg_ParseTuple(args, "sO", &type, &class)) {
+    PyErr_Format(PyExc_TypeError, "Error parsing new world type");
+    return NULL;
+  }
+
+  // add all of our relevant methods to the game world
+  worldAddForgetfulType(gameworld, type, pytype_read, pytype_store, 
+			pytype_delete, pytype_set_key);
+
+  // now, store us so we can look up the Python Methods
+  PyDict_SetItemString(worldtypes, type, class);
+
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_world_get_type(PyObject *self, PyObject *args) {
+  char      *type = NULL;
+  char       *key = NULL;
+
+  if(!PyArg_ParseTuple(args, "ss", &type, &key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Error parsing type and key for world_get_type");
+    return NULL;
+  }
+
+  PyObject *entry = worldGetType(gameworld, type, key);
+  return Py_BuildValue("O", (type == NULL ? Py_None : entry));
+}
+
+PyObject *mudsys_world_put_type(PyObject *self, PyObject *args) {
+  char      *type = NULL;
+  char       *key = NULL;
+  PyObject *entry = NULL;
+
+  if(!PyArg_ParseTuple(args, "ssO", &type, &key, &entry)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Error parsing arguments for world_put_type");
+    return NULL;
+  }
+
+  worldPutType(gameworld, type, key, entry);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_world_save_type(PyObject *self, PyObject *args) {
+  char      *type = NULL;
+  char       *key = NULL;
+
+  if(!PyArg_ParseTuple(args, "ssO", &type, &key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Error parsing type and key for world_save_type");
+    return NULL;
+  }
+
+  worldSaveType(gameworld, type, key);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *mudsys_world_remove_type(PyObject *self, PyObject *args) {
+  char      *type = NULL;
+  char       *key = NULL;
+
+  if(!PyArg_ParseTuple(args, "ss", &type, &key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "Error parsing type and key for world_remove_type");
+    return NULL;
+  }
+
+  PyObject *entry = worldRemoveType(gameworld, type, key);
+  PyObject   *ret = Py_BuildValue("O", (entry == NULL ? Py_None : entry));
+  Py_XDECREF(entry);
+  return ret;
+}
+
+
+
+//*****************************************************************************
 // MudSys module
 //*****************************************************************************
 void PyMudSys_addMethod(const char *name, void *f, int flags, const char *doc) {
@@ -737,7 +931,37 @@
   PyMudSys_addMethod("create_player", mudsys_create_player, METH_VARARGS,
 		     "creates a new player by name. Must be registered "
 		     "after fully created.");
+  PyMudSys_addMethod("add_sock_method", mudsys_add_sock_method, METH_VARARGS,
+		     "adds a new Python method to the Mudsock class");
+  PyMudSys_addMethod("add_char_method", mudsys_add_char_method, METH_VARARGS,
+		     "adds a new Python method to the Char class");
+  PyMudSys_addMethod("add_room_method", mudsys_add_room_method, METH_VARARGS,
+		     "adds a new Python method to the Room class");
+  PyMudSys_addMethod("add_exit_method",  mudsys_add_exit_method, METH_VARARGS,
+		     "adds a new Python method to the Exit class");
+  PyMudSys_addMethod("add_obj_method",  mudsys_add_obj_method, METH_VARARGS,
+		     "adds a new Python method to the Obj class");
+  PyMudSys_addMethod("add_acct_method",  mudsys_add_acct_method, METH_VARARGS,
+		     "adds a new Python method to the Account class");
+  PyMudSys_addMethod("world_add_type", mudsys_world_add_type, METH_VARARGS,
+		     "adds a new type to the world. like, e.g., mob, obj, and "
+                     "room prototypes. Assumes a class with a store and "
+		     "setKey method");
+  PyMudSys_addMethod("world_get_type", mudsys_world_get_type, METH_VARARGS,
+		     "gets a registered item from the world database. Assumes "
+		     "it is a python type, and not a C type. If no type exists "
+		     "return Py_None");
+  PyMudSys_addMethod("world_put_type", mudsys_world_put_type, METH_VARARGS,
+		     "Put a new type into thw world database.");
+  PyMudSys_addMethod("world_save_type", mudsys_world_save_type, METH_VARARGS,
+		     "Saves a world entry if it exists.");
+  PyMudSys_addMethod("world_remove_type", mudsys_world_remove_type,METH_VARARGS,
+		     "Removes a type, and returns a reference to it, or None "
+		     "if it does not exist.");
 
   Py_InitModule3("mudsys", makePyMethods(pymudsys_methods),
 		 "The mudsys module, for all MUD system utils.");
+
+  worldtypes = PyDict_New();
+  Py_INCREF(worldtypes);
 }
diff -ruN versions/nakedmudv3.6/src/scripts/pyobj.c src/scripts/pyobj.c
--- versions/nakedmudv3.6/src/scripts/pyobj.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyobj.c	2008-12-03 02:31:26.000000000 -0500
@@ -315,7 +315,26 @@
 
   OBJ_DATA *obj;
   PYOBJ_CHECK_OBJ_EXISTS(self->uid, obj);
-  objSetKeywords(obj, PyString_AsString(value));
+
+  // clean up empty keywords, and rebuild it
+  LIST           *kwds = parse_keywords(PyString_AsString(value));
+  BUFFER     *new_kwds = newBuffer(1);
+  LIST_ITERATOR *kwd_i = newListIterator(kwds);
+  char            *kwd = NULL;
+
+  ITERATE_LIST(kwd, kwd_i) {
+    // if we already have content, add a comma
+    if(bufferLength(new_kwds) > 0)
+      bufferCat(new_kwds, ", ");
+    bufferCat(new_kwds, kwd);
+  } deleteListIterator(kwd_i);
+
+  // set our keywords
+  objSetKeywords(obj, bufferString(new_kwds));
+
+  // garbage collection
+  deleteListWith(kwds, free);
+  deleteBuffer(new_kwds);
   return 0;
 }
 
@@ -436,15 +455,23 @@
     return -1;
   }
 
-  if (!PyRoom_Check(value)) {
+  ROOM_DATA *room = NULL;
+
+  if(PyRoom_Check(value))
+    room = PyRoom_AsRoom(value);
+  else if(PyString_Check(value))
+    room = worldGetRoom(gameworld, 
+			get_fullkey_relative(PyString_AsString(value),
+					     get_script_locale()));
+  else {
     PyErr_Format(PyExc_TypeError, 
-                    "Room must be a room!");
+		 "Object's room must be a string value or a "
+		 "room object.");
     return -1;
   }
 
   OBJ_DATA *obj;
   PYOBJ_CHECK_OBJ_EXISTS(self->uid, obj);
-  ROOM_DATA *room = PyRoom_AsRoom(value);
   // remove us from whatever we're currently in
   if(objGetRoom(obj))
     obj_from_room(obj);
@@ -593,48 +620,6 @@
   }
 }
 
-PyObject *PyObj_istype(PyObj *self, PyObject *args) {  
-  char *type = NULL;
-
-  // make sure we're getting passed the right type of data
-  if (!PyArg_ParseTuple(args, "s", &type)) {
-    PyErr_Format(PyExc_TypeError, "istype only accepts strings.");
-    return NULL;
-  }
-
-  // pull out the object and check the type
-  OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
-  if(obj != NULL)
-    return Py_BuildValue("i", objIsType(obj, type));
-  else {
-    PyErr_Format(PyExc_StandardError, 
-		 "Tried to check type of nonexistent object, %d.", self->uid);
-    return NULL;
-  }
-}
-
-PyObject *PyObj_settype(PyObj *self, PyObject *args) {  
-  char *type = NULL;
-
-  // make sure we're getting passed the right type of data
-  if (!PyArg_ParseTuple(args, "s", &type)) {
-    PyErr_Format(PyExc_TypeError, "settype only accepts strings.");
-    return NULL;
-  }
-
-  // pull out the object and check the type
-  OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
-  if(obj != NULL) {
-    objSetType(obj, type);
-    return Py_BuildValue("i", 1);
-  }
-  else {
-    PyErr_Format(PyExc_StandardError, 
-		 "Tried to set type of nonexistent object, %d.", self->uid);
-    return NULL;
-  }
-}
-
 //
 // create a new extra description for the object
 PyObject *PyObj_edesc(PyObj *self, PyObject *value) {
@@ -1198,10 +1183,6 @@
 		    "detach an old script from the object, by vnum");
     PyObj_addMethod("isinstance", PyObj_isinstance, METH_VARARGS,
 		    "checks to see if the object inherits from the class");
-    PyObj_addMethod("istype", PyObj_istype, METH_VARARGS,
-		     "checks to see if the object is of the specified type");
-    PyObj_addMethod("settype", PyObj_settype, METH_VARARGS,
-		    "the object will become of the specified type");
     PyObj_addMethod("edesc", PyObj_edesc, METH_VARARGS,
 		    "adds an extra description to the object.");
     PyObj_addMethod("getAuxiliary", PyObj_get_auxiliary, METH_VARARGS,
diff -ruN versions/nakedmudv3.6/src/scripts/pyobj.h src/scripts/pyobj.h
--- versions/nakedmudv3.6/src/scripts/pyobj.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyobj.h	2008-12-01 03:17:39.000000000 -0500
@@ -12,6 +12,9 @@
 //
 //*****************************************************************************
 
+// used by pymudsys. Do not touch!
+PyTypeObject PyObj_Type;
+
 // initialize objects for use. This must be called AFTER all other modules
 // have added in new get/setters and methods to pyobj
 PyMODINIT_FUNC init_PyObj(void);
diff -ruN versions/nakedmudv3.6/src/scripts/pyolc.c src/scripts/pyolc.c
--- versions/nakedmudv3.6/src/scripts/pyolc.c	1969-12-31 19:00:00.000000000 -0500
+++ src/scripts/pyolc.c	2008-12-05 21:37:14.000000000 -0500
@@ -0,0 +1,391 @@
+//*****************************************************************************
+//
+// pyolc.c
+//
+// Provides wrapper functions for Python to interface with OLC2.
+//
+//*****************************************************************************
+#include "../mud.h"
+
+#ifdef MODULE_OLC2
+#include "scripts.h"
+#include "pyplugs.h"
+#include "pysocket.h"
+#include "pyolc.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../olc2/olc.h"
+#include "../olc2/olc_extender.h"
+#include "../items/iedit.h"
+
+
+
+//*****************************************************************************
+// local variables and functions
+//*****************************************************************************
+// a list of methods to add to the module
+LIST  *pyolc_methods = NULL;
+
+// a dictionary for the OLC functions of our various item types
+PyObject *pyitem_olc = NULL;
+
+
+
+//*****************************************************************************
+// raw pyolc methods, used by both items and the olc wrapper functions
+//*****************************************************************************
+void pyolc_do_menu(PyObject *menu, SOCKET_DATA *sock, PyObject *data) {
+  PyObject    *pysock = socketGetPyFormBorrowed(sock);
+  PyObject       *ret = PyObject_CallFunction(menu, "OO", pysock, data);
+  if(ret == NULL)
+    log_pyerr("pyolc_do_menu failed");
+  Py_XDECREF(ret);
+}
+
+int pyolc_do_chooser(PyObject *chooser, SOCKET_DATA *sock, PyObject *data,
+		     const char *option) {
+  PyObject    *pysock = socketGetPyFormBorrowed(sock);
+  PyObject     *pyret = PyObject_CallFunction(chooser, "OOs", pysock, data,
+					      option);
+  int             ret = MENU_CHOICE_INVALID;
+  if(pyret == NULL)
+    log_pyerr("pyolc_do_chooser failed: %s", option);
+  else if(PyInt_Check(pyret))
+    ret = (int)PyInt_AsLong(pyret);
+  Py_XDECREF(pyret);
+  return ret;
+}
+
+bool pyolc_do_parser(PyObject *parser, SOCKET_DATA *sock, PyObject *data,
+		     int choice, const char *arg) {
+  PyObject    *pysock = socketGetPyFormBorrowed(sock);
+  PyObject     *pyret = PyObject_CallFunction(parser, "OOis", pysock, data,
+					      choice, arg);
+  bool            ret = FALSE;
+  if(pyret == NULL)
+    log_pyerr("pyolc_do_parser failed: %d, %s", choice, arg);
+  else if(PyObject_IsTrue(pyret))
+    ret = TRUE;
+  Py_XDECREF(pyret);
+  return ret;
+}
+
+void pyolc_do_from_proto(PyObject *from_proto, PyObject *data) {
+  if(from_proto != NULL) {
+    PyObject *ret = PyObject_CallFunction(from_proto, "O", data);
+    if(ret == NULL)
+      log_pyerr("Error in pyolc_do_from_proto");
+    Py_XDECREF(ret);
+  }
+}
+
+void pyolc_do_to_proto(PyObject *to_proto, PyObject *data, BUFFER *buf) {
+  if(to_proto != NULL) {
+      PyObject *ret = PyObject_CallFunction(to_proto, "O", data);
+      if(ret == NULL)
+	log_pyerr("Error in pyolc_do_to_proto");
+      else if(PyString_Check(ret))
+	bufferCat(buf, PyString_AsString(ret));
+      Py_XDECREF(ret);
+  }
+}
+
+void pyolc_do_copyto(PyObject *from, PyObject *to) {
+  PyObject *ret = PyObject_CallMethod(from, "copyTo", "O", to);
+  if(ret == NULL)
+    log_pyerr("Error in pyolc_do_copyto");
+  Py_XDECREF(ret);
+}
+
+void pyolc_do_save(PyObject *saver, PyObject *data) {
+  if(saver != NULL && saver != Py_None) {
+    PyObject *ret = PyObject_CallFunction(saver, "O", data);
+    if(ret == NULL)
+      log_pyerr("Error in pyolc_do_save");
+    Py_XDECREF(ret);    
+  }
+}
+
+void pyolc_do_delete(PyObject *pyolc) {
+  Py_XDECREF(pyolc);
+}
+
+
+
+//*****************************************************************************
+// Python OLC wrapper
+//*****************************************************************************
+void pyolc_menu(SOCKET_DATA *sock, PyObject *olc) {
+  PyObject *working_copy = PyDict_GetItemString(olc, "working_copy");
+  PyObject         *menu = PyDict_GetItemString(olc, "menu");
+  pyolc_do_menu(menu, sock, working_copy);
+}
+
+int pyolc_chooser(SOCKET_DATA *sock, PyObject *olc, const char *option) {
+  PyObject *working_copy = PyDict_GetItemString(olc, "working_copy");
+  PyObject      *chooser = PyDict_GetItemString(olc, "chooser");
+  return pyolc_do_chooser(chooser, sock, working_copy, option);
+}
+
+bool pyolc_parser(SOCKET_DATA *sock,PyObject *olc,int option,const char *arg) {
+  PyObject *working_copy = PyDict_GetItemString(olc, "working_copy");
+  PyObject       *parser = PyDict_GetItemString(olc, "parser");
+  return pyolc_do_parser(parser, sock, working_copy, option, arg);
+}
+
+void pyolc_saver(PyObject *olc) {
+  PyObject *working_copy = PyDict_GetItemString(olc, "working_copy");
+  PyObject    *orig_copy = PyDict_GetItemString(olc, "orig_copy");
+  PyObject        *saver = PyDict_GetItemString(olc, "saver");
+
+  // do we need to copy from our working copy to our original?
+  if(orig_copy != working_copy)
+    pyolc_do_copyto(working_copy, orig_copy);
+
+  // do we need to save this info to disk?
+  if(saver != Py_None)
+    pyolc_do_save(saver, orig_copy);
+}
+
+void pyolc_deleter(PyObject *olc) {
+  Py_DECREF(olc);
+}
+
+PyObject *pyolc_do_olc(PyObject *self, PyObject *args) {
+  PyObject      *pymenu = NULL;
+  PyObject   *pychooser = NULL;
+  PyObject    *pyparser = NULL;
+  PyObject     *pysaver = NULL;
+  PyObject      *pydata = NULL;
+  PyObject      *pysock = NULL;
+  SOCKET_DATA     *sock = NULL;
+  bool         autosave = FALSE;
+
+  // parse out our socket and functions
+  if(!PyArg_ParseTuple(args, "OOOOOO|b", 
+		       &pysock, &pymenu, &pychooser, &pyparser,
+		       &pysaver, &pydata, &autosave)) {
+    PyErr_Format(PyExc_TypeError,"Invalid number arguments supplied to do_olc");
+    return NULL;
+  }
+
+  // make sure our socket is in fact a socket
+  if(PySocket_Check(pysock))
+    sock = PySocket_AsSocket(pysock);
+  else {
+    PyErr_Format(PyExc_TypeError, "First argument must be a socket.");
+    return NULL;
+  }
+
+  // figure out what our C functions will be
+  void    *menu = pyolc_menu;
+  void *chooser = pyolc_chooser;
+  void  *parser = pyolc_parser;
+  void   *saver = pyolc_saver;
+  void *deleter = pyolc_deleter;
+  bool can_copy = (PyObject_HasAttrString(pydata, "copy") && 
+		   PyObject_HasAttrString(pydata, "copyTo"));
+
+  // figure out our remaining C OLC functions, if any?
+  if(pyparser == Py_None)
+    parser = NULL;
+
+  // we do save if we have a save function, or we have a copy and a copyTo func
+  if(autosave == TRUE || (pysaver == Py_None && !can_copy))
+    saver = NULL;
+
+  // build up our OLC Wrapper
+  PyObject *wrapper = PyDict_New();
+  PyDict_SetItemString(wrapper, "menu",      pymenu);
+  PyDict_SetItemString(wrapper, "chooser",   pychooser);
+  PyDict_SetItemString(wrapper, "parser",    pyparser);
+  PyDict_SetItemString(wrapper, "saver",     pysaver);
+
+  // set our original copy
+  PyDict_SetItemString(wrapper, "orig_copy", pydata);
+
+  // do we want to work on the original copy directly, or no?
+  if(autosave == TRUE || !can_copy)
+    PyDict_SetItemString(wrapper, "working_copy", pydata);
+  else {
+    PyObject *working_copy = PyObject_CallMethod(pydata, "copy", NULL);
+    if(working_copy != NULL)
+      PyDict_SetItemString(wrapper, "working_copy", working_copy);
+    // work on the original copy instead
+    else {
+      log_pyerr("Error calling copy in pyolc_do_olc");
+      PyDict_SetItemString(wrapper, "working_copy", pydata);
+    }
+    Py_XDECREF(working_copy);
+  }
+
+  // add the OLC functions
+  do_olc(sock, menu, chooser, parser, NULL, NULL, deleter, saver, wrapper);
+  return Py_BuildValue("O", Py_None);
+}
+
+
+
+//*****************************************************************************
+// Item OLC
+//*****************************************************************************
+void pyitem_olc_menu(SOCKET_DATA *sock, PyObject *data) {
+  char *str = PyString_AsString(PyObject_GetAttrString(data, "__item_type__"));
+  PyObject *olc_funcs = PyDict_GetItemString(pyitem_olc, str);
+  PyObject      *menu = PyDict_GetItemString(olc_funcs, "menu");
+  pyolc_do_menu(menu, sock, data);
+}
+
+int pyitem_olc_chooser(SOCKET_DATA *sock, PyObject *data, const char *option) {
+  char *str = PyString_AsString(PyObject_GetAttrString(data, "__item_type__"));
+  PyObject *olc_funcs = PyDict_GetItemString(pyitem_olc, str);
+  PyObject   *chooser = PyDict_GetItemString(olc_funcs, "chooser");
+  return pyolc_do_chooser(chooser, sock, data, option);
+}
+
+bool pyitem_olc_parser(SOCKET_DATA *sock, PyObject *data,
+		       int choice, const char *arg) {
+  char *str = PyString_AsString(PyObject_GetAttrString(data, "__item_type__"));
+  PyObject *olc_funcs = PyDict_GetItemString(pyitem_olc, str);
+  PyObject    *parser = PyDict_GetItemString(olc_funcs, "parser");
+  return pyolc_do_parser(parser, sock, data, choice, arg);
+}
+
+void pyitem_olc_from_proto(PyObject *data) {
+  char *str = PyString_AsString(PyObject_GetAttrString(data, "__item_type__"));
+  PyObject  *olc_funcs = PyDict_GetItemString(pyitem_olc, str);
+  PyObject *from_proto = PyDict_GetItemString(olc_funcs, "from_proto");
+  pyolc_do_from_proto(from_proto, data);
+}
+
+void pyitem_olc_to_proto(PyObject *data, BUFFER *buf) {
+  char *str = PyString_AsString(PyObject_GetAttrString(data, "__item_type__"));
+  PyObject  *olc_funcs = PyDict_GetItemString(pyitem_olc, str);
+  PyObject   *to_proto = PyDict_GetItemString(olc_funcs, "to_proto");
+  pyolc_do_to_proto(to_proto, data, buf);
+}
+
+PyObject *pyolc_item_add_olc(PyObject *self, PyObject *args) {
+  PyObject       *pymenu = NULL;
+  PyObject    *pychooser = NULL;
+  PyObject     *pyparser = NULL;
+  PyObject *pyfrom_proto = NULL;
+  PyObject   *pyto_proto = NULL;
+  char             *type = NULL;
+
+  // parse out our socket and functions
+  if(!PyArg_ParseTuple(args, "sOOOOO", &type, &pymenu, &pychooser,&pyparser,
+		       &pyfrom_proto, &pyto_proto)) {
+    PyErr_Format(PyExc_TypeError,"Invalid number arguments supplied to do_olc");
+    return NULL;
+  }
+
+  // what are all the functions we need to pass to item_add_olc?
+  void       *menu = pyitem_olc_menu;
+  void    *chooser = pyitem_olc_chooser;
+  void     *parser = NULL;
+  void *from_proto = NULL;
+  void   *to_proto = NULL;
+
+  // figure out our remaining C OLC functions, if any?
+  if(pyparser != Py_None)
+    parser = pyitem_olc_parser;
+  if(pyfrom_proto != Py_None)
+    from_proto = pyitem_olc_from_proto;
+  if(pyto_proto != Py_None)
+    to_proto = pyitem_olc_to_proto;
+
+  // A new dictionary, and add all of our Python OLC functions
+  PyObject *item_olc = PyDict_New();
+  PyDict_SetItemString(item_olc, "menu",       pymenu);
+  PyDict_SetItemString(item_olc, "chooser",    pychooser);
+  PyDict_SetItemString(item_olc, "parser",     pyparser);
+  PyDict_SetItemString(item_olc, "from_proto", pyfrom_proto);
+  PyDict_SetItemString(item_olc, "to_proto",   pyto_proto);
+  PyDict_SetItemString(pyitem_olc, type, item_olc);
+
+  // add the OLC functions
+  item_add_olc(type, menu, chooser, parser, from_proto, to_proto);
+  return Py_BuildValue("O", Py_None);
+}
+
+
+PyObject *pyolc_extend(PyObject *self, PyObject *args) {
+  PyObject       *pymenu = NULL;
+  PyObject    *pychooser = NULL;
+  PyObject     *pyparser = NULL;
+  PyObject *pyfrom_proto = NULL;
+  PyObject   *pyto_proto = NULL;
+  char             *type = NULL;
+  char              *opt = NULL;
+
+  // parse out our socket and functions
+  if(!PyArg_ParseTuple(args, "ssOO|OOO", &type, &opt, &pymenu, &pychooser,&pyparser,
+		       &pyfrom_proto, &pyto_proto)) {
+    PyErr_Format(PyExc_TypeError,"Invalid number arguments supplied to do_olc");
+    return NULL;
+  }
+
+  // What OLC are we trying to extend?
+  OLC_EXTENDER *ext = NULL;
+  if(!strcmp(type, "medit"))
+    ext = medit_extend;
+  else if(!strcmp(type, "oedit"))
+    ext = oedit_extend;
+  else if(!strcmp(type, "redit"))
+    ext = redit_extend;
+  else {
+    PyErr_Format(PyExc_TypeError,"Extend options: medit, oedit, and redit.");
+    return NULL;
+  }
+
+  extenderRegisterPyOpt(ext, *opt, pymenu, pychooser, pyparser, pyfrom_proto,
+			pyto_proto);
+  return Py_BuildValue("i", 1);
+}
+
+
+
+//*****************************************************************************
+// PyOLC module
+//*****************************************************************************
+void PyOLC_addMethod(const char *name, void *f, int flags, const char *doc) {
+  // make sure our list of methods is created
+  if(pyolc_methods == NULL) pyolc_methods = newList();
+
+  // make the Method def
+  PyMethodDef *def = calloc(1, sizeof(PyMethodDef));
+  def->ml_name     = strdup(name);
+  def->ml_meth     = (PyCFunction)f;
+  def->ml_flags    = flags;
+  def->ml_doc      = (doc ? strdup(doc) : NULL);
+  listPut(pyolc_methods, def);
+}
+
+PyMODINIT_FUNC
+init_PyOLC(void) {
+  // add all of our methods
+  PyOLC_addMethod("do_olc", pyolc_do_olc, METH_VARARGS,"Enter the OLC editor.");
+  PyOLC_addMethod("item_add_olc", pyolc_item_add_olc, METH_VARARGS, 
+		  "Add a new OLC for editing a Python item type.");
+  PyOLC_addMethod("extend", pyolc_extend, METH_VARARGS,
+		  "Extends an already existing OLC command");
+
+  // create the module
+  PyObject *m = Py_InitModule3("olc", makePyMethods(pyolc_methods),
+			       "The Python module for OLC.");
+
+  // set some important OLC values as well
+  PyObject_SetAttrString(m, "MENU_NOCHOICE", Py_BuildValue("i", MENU_NOCHOICE));
+  PyObject_SetAttrString(m, "MENU_CHOICE_INVALID",
+			 Py_BuildValue("i", MENU_CHOICE_INVALID));
+  PyObject_SetAttrString(m, "MENU_CHOICE_OK",
+			 Py_BuildValue("i", MENU_CHOICE_OK));
+
+  pyitem_olc = PyDict_New();
+}
+#endif // MODULE_OLC2
diff -ruN versions/nakedmudv3.6/src/scripts/pyolc.h src/scripts/pyolc.h
--- versions/nakedmudv3.6/src/scripts/pyolc.h	1969-12-31 19:00:00.000000000 -0500
+++ src/scripts/pyolc.h	2008-12-01 01:29:24.000000000 -0500
@@ -0,0 +1,23 @@
+#ifndef __PYOLC_H
+#define __PYOLC_H
+//*****************************************************************************
+//
+// pyolc.h
+//
+// A set of system level commands and variables that may be needed by python,
+// but which are not neccessarily needed by scripts.
+//
+//*****************************************************************************
+
+// init the Python olc module for use
+PyMODINIT_FUNC init_PyOLC(void);
+
+//
+// Adds a new method function (i.e. void *f) to the olc module. Name is the name
+// of the function, f is the PyCFunction implementing the new method, flags is
+// the type of method beings used (almost always METH_VARARGS), and doc is an
+// (optional) description of what the method does. For examples on how to add
+// new methods, see pymud.c
+void PyOLC_addMethod(const char *name, void *f, int flags, const char *doc);
+
+#endif //__PYOLC_H
diff -ruN versions/nakedmudv3.6/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- versions/nakedmudv3.6/src/scripts/pyplugs.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyplugs.c	2008-12-01 22:46:45.000000000 -0500
@@ -57,10 +57,7 @@
 bool PyModule_Reload(char *fname, char *mname) {
   PyObject *code = Py_CompileFile(fname);
   if(code == NULL) {
-    char *tb = getPythonTraceback();
-    log_string("Error in module file: %s\r\n"
-	       "\r\nTraceback is:\r\n%s\r\n", fname, tb);
-    free(tb);
+    log_pyerr("Error in module file: %s", fname);
     return FALSE;
   }
   // no errors occured... load the module into our package
@@ -75,12 +72,8 @@
 	PyObject *tbList = PyObject_CallMethod(old_mod, "__unload__", "");
 
 	// encountered an error with the unload function
-	if(tbList == NULL) {
-	  char *tb = getPythonTraceback();
-	  log_string("Encountered error in %s.__unload__():\r\n"
-		     "\r\nTraceback is:\r\n%s\r\n", mname, tb);
-	  free(tb);
-	}
+	if(tbList == NULL)
+	  log_pyerr("Encountered error in %s.__unload__()", mname);
 	Py_XDECREF(tbList);
       }
       Py_XDECREF(old_mod);
@@ -88,10 +81,7 @@
 
     PyObject *module = PyImport_ExecCodeModule(mname, code);
     if(module == NULL) {
-      char *tb = getPythonTraceback();
-      log_string("Error in module file: %s\r\n"
-		 "\r\nTraceback is:\r\n%s\r\n", fname, tb);
-      free(tb);
+      log_pyerr("Error in module file: %s", fname);
       return FALSE;
     }
     else
@@ -173,15 +163,8 @@
       // we now abandon bootup if we fail to load a Python module, because it
       // can have potentially dangerous affects on the loading of other modules
       // Thanks to Thirsteh for pointing this out.
-      BUFFER *buf = newBuffer(1);
-      char *tb = getPythonTraceback();
-      bprintf(buf, "Error loading module, %s:\r\n%s\r\n"
-	           "Bootup aborted. MUD shutting down.", mname, tb);
-      log_string(bufferString(buf));
-      printf("%s", bufferString(buf));
-      
-      deleteBuffer(buf);
-      free(tb);
+      log_pyerr("Error loading module, %s:", mname);
+      log_string("Bootup aborted. MUD shutting down.");
       closedir(dir);
       exit(1);
     }
@@ -252,6 +235,22 @@
     return chrRetval;
 }
 
+void log_pyerr(const char *format, ...) {
+  // get the traceback, and print our message
+  char *tb = getPythonTraceback();
+  if(tb != NULL) {
+    static char buf[MAX_BUFFER];
+    va_list args;
+    va_start(args, format);
+    vsnprintf(buf, MAX_BUFFER, format, args);
+    va_end(args);
+
+    log_string("%s\r\n\r\n%s\r\n", buf, tb);
+    free(tb);
+  }
+}
+
+
 PyGetSetDef *makePyGetSetters(LIST *getsetters) {
   PyGetSetDef *getsets = calloc(listSize(getsetters)+1,sizeof(PyGetSetDef));
   LIST_ITERATOR  *gs_i = newListIterator(getsetters);
diff -ruN versions/nakedmudv3.6/src/scripts/pyplugs.h src/scripts/pyplugs.h
--- versions/nakedmudv3.6/src/scripts/pyplugs.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyplugs.h	2008-12-01 22:09:17.000000000 -0500
@@ -17,6 +17,12 @@
 char *getPythonTraceback(void);
 
 //
+// If we've enountered an error in python, log the traceback along
+// with the specified message
+void log_pyerr(const char *mssg, ...)
+__attribute__ ((format (printf, 1, 2)));
+
+//
 // initialize all of our plugs with python
 void init_pyplugs();
 
